<?php
require_once "configuration.php";
require_once 'Mail/RFC822.php';
require_once 'valdate.php';

// ----------------- POPULATE FIELDS ---------------------------------

function populate_fields() {
global $allfields, $fields;
  $fields["submitted"] = "";
  $fields["zzerr"] = "";
  $fields["zzdberr"] = "";
  $fields["errormessage"] = "";
  
 foreach ($allfields as $key => $value) 
 {
    $fields[$key] = "";  // creates a reference
 }
}

// ----------------- POPULATE FRIENDS FIELDS ---------------------------------

function populate_friends_fields($rowcount) {
global $fields, $keyid, $field_guid;
global $field_email, $field_fname, $field_lname;

  $fields["submitted"] = "";
  $fields["zzerr"] = "";
  $fields["zzdberr"] = "";
  $fields["errormessage"] = "";
  
  $fields[$field_guid] = PostVal($field_guid);
  $fields[$keyid] = PostVal($keyid);

  $fields[$field_fname] = str_replace("\"","'", stripslashes(PostVal($field_fname)));  
  $fields[$field_lname] = str_replace("\"","'", stripslashes(PostVal($field_lname)));  
  
 for($i = 1; $i <= $rowcount; $i++) 
 {
    $fields[$field_email.$i] = str_replace("\"","'", stripslashes(PostVal($field_email.$i)));  
    $fields[$field_fname.$i] = str_replace("\"","'", stripslashes(PostVal($field_fname.$i)));  
    $fields[$field_lname.$i] = str_replace("\"","'", stripslashes(PostVal($field_lname.$i)));  
 }
}

// ----------------- BLANK FRIENDS FIELDS ---------------------------------

function blank_friends_fields($rowcount) {
global $fields, $keyid, $field_guid;
global $field_email, $field_fname, $field_lname;

  $fields["submitted"] = "";
  $fields["zzerr"] = "";
  $fields["zzdberr"] = "";
  $fields["errormessage"] = "";
  
  $fields[$field_guid] = PostVal($field_guid);
  $fields[$keyid] = PostVal($keyid);

  $fields[$field_fname] = str_replace("\"","'", stripslashes(PostVal($field_fname)));  
  $fields[$field_lname] = str_replace("\"","'", stripslashes(PostVal($field_lname)));  
  
 for($i = 1; $i <= $rowcount; $i++) 
 {
    $fields[$field_email.$i] = "";
    $fields[$field_fname.$i] = "";
    $fields[$field_lname.$i] = "";
 }
}

// ----------------- POST VAL ---------------------------------

function PostVal($value) 
{
  if (isset($_POST[$value]))
    return $_POST[$value];
  else 
    return "";
}

// ----------------- GET VAL ---------------------------------

function GetVal($value) 
{
  if (isset($_GET[$value]))
    return $_GET[$value];
  else 
    return "";
}

// ----------------- GET KEY ---------------------------------
// check the fields array to see if a key of interest exists,
// if it does return the value, else return blank.
function getkey($key, $arr) 
{
  if (array_key_Exists($key, $arr))
    return $arr[$key];
  else 
    return "";
}

// 

// ----------------- SUBSCRIBE USER ---------------------------------
function subscribe_user( ) 
{   
   $ok = true; 
   save_user();
   return $ok;
}

// ----------------- myCheckDNSRR ---------------------------------
function myCheckDNSRR($hostName, $recType = '')
{
 if(!empty($hostName)) {
   if( $recType == '' ) $recType = "MX";
   exec("nslookup -type=$recType $hostName", $result);
   // check each line to find the one that starts with the host
   // name. If it exists then the function succeeded.
   foreach ($result as $line) {
     if(eregi("^$hostName",$line)) {
       return true;
     }
   }
   // otherwise there was no mail handler for the domain
   return false;
 }
 return false;
}

// ----------------- VALIDATE EMAIL DOMAIN ------------------------
// will check to ensure the domain portion of the email address 
// exists.
function validate_domain($email) 
{
  // take a given email address and split it into the username and domain.
  // true = this is a valid email domain!
  // false = this email domain doesn't exist! bad dog! no biscuit!
 
  list($userName, $mailDomain) = split("@", $email);
   // echo  "mailDomain: $mailDomain<br><br>\n";
  return (myCheckDNSRR($mailDomain, "MX"));  // windows need to do ourselves
  // NON WINDOWS: return (checkdnsrr($mailDomain, "MX"));
}

// ----------------- VALIDATE EMAIL ADDRESS ---------------------------------
function validate_address($address) 
{
  return  Mail_RFC822::isValidInetAddress( $address, true);
}

// ----------------- VALIDATE USER FORM ---------------------------------

function validate_user_form() {
  global $allfields;
  global $requiredfields;
  global $ignorefields;
  global $fields, $field_email, $field_bdate;
  // returns the list of fields validated.
  // returns error list of values that are required but not showing
  // or not existant in the database.

  $ok = true;
  
  populate_fields();

  //print_r($_POST);
  //echo "<br><br>";
  
  $dberrorlist = "";
  $errorlist = "";
  foreach ($_POST as $key => $value)
  {
	 $key = strtolower($key);
  	 
	// echo "[$key] = [" . $value . "]<br/>\n";
	 
	 if (in_array($key, $ignorefields) ) 
	 {
	    // echo $key . " IGNORED.<br/>\n";
	    continue;
	 }
	 
	 if (!array_key_exists($key, $allfields))  
	 { 
	    //  die("Bad Key Value");	   
	    $dberrorlist .= "<li>" . $key . "</li>\n";
	    $ok = false;
	 }
	 else 
	 {
  	    $fields[$key] = str_replace("\"","'", stripslashes($value));
//	    echo "key exists in ALLFIELDS<br/>\n";
	    if (in_array($key, $requiredfields)) 
		  if (strlen($value) == 0) 
		  { 
	         //echo "Field Required for $key <br/>\n";
        	 $ok = false;
		     $errorlist .= "<li>" . $allfields[$key] . "</li>\n";
		  }
	 }
  }
  
  // verify emaiil address
  if (($fields[$field_email] <> "") and (validate_address($fields[$field_email]) == false))
  {
      $ok = false;
      $errorlist .= "<li>Invalid Email Address.</li>\n";
  }

  // verify domain
  if (($fields[$field_email] <> "") and (validate_domain($fields[$field_email]) == false))
  {
      $ok = false;
      $errorlist .= "<li>Invalid Email Address Domain.</li>\n";
  }
   
  // verify NOT a bot
     if(($_SESSION['security_code'] == $_POST['security_code']) && (!empty($_SESSION['security_code'])) ) {
      // Insert you code for processing the form here
   } else {
      $ok = false;
      $errorlist .= "<li>Sorry, you have provided an invalid security code.</li>\n";	  
   }

  // verify dates
  if (($fields[$field_bdate] <> "") and (isDate($fields[$field_bdate]) == false))
  {
      $ok = false;
      $errorlist .= "<li>Invalid birth date.</li>\n";
  }
 
//  $fields["zzdberr"] = $dberrorlist;
//  $fields["zzerr"] = $errorlist;

  if ($ok == false) 
  {
      $fields["errormessage"] = "<br/>";
	  if (strlen($dberrorlist) > 0)
		   $fields["errormessage"] .= "<strong>System Error, following fields are not in the database:</strong><ul>" . $dberrorlist . "</ul>";
      if (strlen($errorlist) > 0) 
	      $fields["errormessage"] .= "<strong>The following fields are required:</strong><ul>" . $errorlist . "</ul>";
  }	  

   return $ok;   
}


// ----------------- VALID GUID ---------------------------------
function valid_guid($guid)
{
   global $tablename, $keyid;
   global $database;

   $c_get = "Select $keyid  From " . $database.".".$tablename . 
       " where guid = '" . $guid . "'";
//   echo $c_get . "<br><br>\n";

   $result = mysql_query($c_get) or die('valid_guid - get guid query failed: ' . mysql_error());
   $num_rows = mysql_num_rows($result);
   return ($num_rows > 0);
}

// ----------------- GET KEYID FIELD ---------------------------------
function get_id($guid)
{
   global $dbConn;
   global $tablename, $field_keyid;
   global $database;

   $c_get = "Select $field_keyid  From " . $database.".".$tablename . 
       " where guid = '" . $guid . "'";
//   echo $c_get . "<br><br>\n";

   $result = mysql_query($c_get) or die('valid_guid - get guid query failed: ' . mysql_error());
//   $num_rows = mysql_num_rows($result);
   $line = mysql_fetch_array($result, MYSQL_ASSOC);
   return $line[$field_keyid];
}

// ----------------- GET EMAIL FIELD ---------------------------------
function get_email($guid)
{
	// prolly make this more generic
   global $dbConn;
   global $tablename, $field_email;
   global $database;

   $c_get = "Select $field_email  From " . $database.".".$tablename . 
       " where guid = '" . $guid . "'";
//   echo $c_get . "<br><br>\n";

   $result = mysql_query($c_get) or die('valid_guid - get guid query failed: ' . mysql_error());
//   $num_rows = mysql_num_rows($result);
   $line = mysql_fetch_array($result, MYSQL_ASSOC);
   return $line[$field_email];
}

// ----------------- SUBSCRIPTION CANCEL ---------------------------------
function subscription_cancel($guid) 
{
   global $dbConn;
   global $tablename;
   global $database;
   global $field_email, $field_guid;
   global $field_hasCanceled, $field_hasCanceledDate;

   $ok = true;
   $guid = sql_quote($guid);
   $email = get_email($guid);
   
   // get email for guid.
   // then all NONE canceled emails will be canceled that correspond to the same email address as was confirmed.
   // this will protect customers from getting frustrated if they accidentilly register twice.
   // should do something about checking to see if the email address is already existing during confirmation.
   // if does exist, then instead of creating new account, (for active accounts)  the other should be returned
   // instead with a message saying its already active.  OR update it and send it to customer to confirm.
   
   
   $c_update = "Update " . $tablename . " set $field_hasCanceled=1, $field_hasCanceledDate=NOW() where $field_email = '" . $email ."' and $field_hasCanceled=0";
//   $c_update = "Update " . $tablename . " set $field_hasCanceled=1, $field_hasCanceledDate=NOW() where $field_guid = '" . $guid ."'";
    //echo $c_update . "<br><br>\n";

   $result = mysql_query($c_update)
           or die('subscription_cancel - update error: '.mysql_errno().', '.mysql_error());
   return $ok;
}

// ----------------- SUBSCRIPTION CONFIRMED ---------------------------------
function subscription_confirmed( $guid )
{
   global $field_keyid;
   global $fields;

   $ok = false; 
   
   if (valid_guid($guid) == true) 
   { 
      if (get_user_details("guid", $guid ) == true)
{
	     $ok = set_opted_state(true, $fields[$field_keyid]);
}
   }
   return $ok;
}

// ----------------- Set Opted In ---------------------------------
function set_opted_state($isOpted, $id)
{
   global $dbConn;
   global $tablename;
   global $database;
   global $field_keyid;
   global $field_isOptedIn;

   $id = sql_quote($id);
   if ($isOpted == true)
   {
     $c_update = "Update " . $tablename . 
                " set " . $field_isOptedIn . " = 1 where ". $field_keyid ." = ". $id;
//           echo $c_update . "<br><br>\n";
//	   	die("here aa");

    mysql_query($c_update)
               or die('set_opted_state - update error: '.mysql_errno().', '.mysql_error());
   }
   else
   {
    // cancel opted I think this function exists in this file.
   }
   return true;
}

// ----------------- Get User Details  ---------------------------------
function get_user_details($keyname, $value )
{
   global $dbConn;
   global $tablename;
   global $database;
   global $field_keyid, $field_fname, $field_lname;
   global $field_email, $field_guid;
   global $field_isOptedIn;
   global $fields;

   $ok = true; 

   // the value is expected to work at this point.
      
   $value = sql_quote($value);
   $c_get = "Select $field_keyid, $field_guid, $field_email, $field_fname, $field_lname, $field_isOptedIn From " . $database.".".$tablename;
   if ($keyname == "guid")
   {
   	$c_get .= " where $field_guid = '" . $value . "'";
   }
   else if ($keyname == "email")
   {
      $c_get .= " where $field_email = '" . $value . "'";
   }
      //echo $c_get . "<br><br>\n";
      //die("here");

      $result = mysql_query($c_get) or die('get_user_details - get user details query failed: ' . mysql_error());
      $num_rows = mysql_num_rows($result);
      if ($num_rows == 0) {
         $ok = false;
//	     echo "NO MATCH<br/>\n";
	  }
      else 
      {
         $line = mysql_fetch_array($result, MYSQL_ASSOC);
      
         if ($line[$field_keyid] == "")
	        $ok = false; 
         else
	     {
	        $fields[$field_keyid] = $line[$field_keyid];
	        $fields[$field_guid] = $line[$field_guid];
	        $fields[$field_email] = $line[$field_email];
	        $fields[$field_fname] = $line[$field_fname];
	        $fields[$field_lname] = $line[$field_lname];
	     }
      }

   return $ok;
}

// ----------------- SAVE FRIENDS -----------------------------
function save_friends($rowcount)
{
global $field_email, $field_fname, $field_lname;
global $fields, $field_keyid;

  $friendname = $fields[$field_fname] .' '. $fields[$field_lname];
  // echo "friendname = ".$friendname."<br><br>\n";
  for($i = 1; $i <= $rowcount; $i++) 
  {
	 $email = getkey($field_email.$i, $fields);
	 $fname = getkey($field_fname.$i, $fields);
	 $lname = getkey($field_lname.$i, $fields);

	 if (($email <> "") and ($fname <> "") and ($lname <> "")) 
	 {
	    save_a_friend($fname, $lname, $email, $fields[$field_keyid]);
	    send_friend_mail($fname, $lname, $email, $friendname);
	 }
  }
}

// ----------------- SAVE A FRIEND -----------------------------
function save_a_friend($fname, $lname, $email, $refer_id)
{
global $dbConn;
global $tablename;
global $fields;
global $allfields;
global $field_fname, $field_lname, $field_email, $field_guid, $field_referredby_id;

  // Create Key
  $fields[$field_guid] = md5(uniqid());

  $valuelist = "";
  $fieldlist = "$field_fname, $field_lname, $field_email, $field_guid, $field_referredby_id";

  $valuelist .= "'" . sql_quote($fname) . "',";
  $valuelist .= "'" . sql_quote($lname) . "',";
  $valuelist .= "'" . sql_quote($email) . "',";
  $valuelist .= "'" . $fields[$field_guid] . "',";
  $valuelist .= "'" . $refer_id . "'";
 
   // better, difficult to guess
   //$better_token = md5(uniqid(rand(), true));
 
 
   // echo "fieldlist: " . $fieldlist . "<br/>\n";
   // echo "valuelist: " . $valuelist . "<br/>\n";

   $c_insert = "INSERT INTO " . $tablename . 
       " (" . $fieldlist . " )VALUES ( ". $valuelist .")";
   //echo $c_insert . "<br><br>\n";

   $c_page = mysql_query($c_insert)
      or die('counter INSERT error: '.mysql_errno().', '.mysql_error());

   // Closing connection
   // mysql_close($dbConn);
}

// ----------------- SAVE USER ---------------------------------
function save_user()
{
global $dbConn;
global $tablename;
global $fields;
global $allfields;
global $field_guid, $field_isOptedIn;
global $requireDoubleOpt;

 $fieldlist = "";
 $valuelist = "";
 
 foreach ($fields as $key => $value) 
 {
    if (array_key_exists($key, $allfields) and ($value <> ""))  
    { 
       $fieldlist .= $key .",";
       $valuelist .= "'" . sql_quote($value) . "',";
    }
 }
 
 // works only in PHP 5 and later versions
$guid = md5(uniqid());
$fields[$field_guid] = $guid;

// better, difficult to guess
//$better_token = md5(uniqid(rand(), true));

 $fieldlist .= $field_guid;
 $valuelist .= "'" . $guid ."'";
 
 if ($requireDoubleOpt == false)
 {
     $fieldlist .= "," . $field_isOptedIn; //.",";
     $valuelist .= ",1";
 }	

// echo "fieldlist: " . $fieldlist . "<br/>\n";
// echo "valuelist: " . $valuelist . "<br/>\n";

 $c_insert = "INSERT INTO " . $tablename . 
       " (" . $fieldlist . " )VALUES ( ". $valuelist .")";
 //echo $c_insert . "<br><br>\n";
 //die("here");
 
 $c_page = mysql_query($c_insert)
      or die('SAVE USER - INSERT error: '.mysql_errno().', '.mysql_error());

// Closing connection
// mysql_close($dbConn);
}


// ----------------- REDIRECT ---------------------------------
function redirect($page)
{
   header("Location: " . MakeLink($page) ) ; // http://$host$uri/$page");   
   exit;
}

// ----------------- MAKE LINK ---------------------------------
function MakeLink($page)
{
   $host  = $_SERVER['HTTP_HOST'];
   if (strpos('\/', substr($page, 0, 1)) ==  FALSE)
   {
      $uri = rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
      return "http://$host$uri/$page";
//      header("Location: http://$host$uri/$page");
   }
   else
   {
      return "http://$host$page";
      // header("Location: http://$host$page");
   }

}

// ----------------- SEND MAIL ---------------------------------
function sendmail($from_email, $to_email, $subject, $body, $persist)
{
global $SMTP_Address, $SMTP_Port, $SMTP_Auth, $SMTP_UserName;
global $SMTP_Password, $EHLO_LocalHost;
   include_once 'Mail.php';

   $headers['From']    = $from_email;
   $headers['To']      = $to_email;
   $headers['Subject'] = $subject;
   $recipients = $to_email;

   $params["host"] = $SMTP_Address;         // The server to connect. Default is localhost 
   $params["port"] = $SMTP_Port;            // The port to connect. Default is 25 
   $params["auth"] = $SMTP_Auth;            // Whether or not to use SMTP authentication. Default is FALSE 
   $params["username"] = $SMTP_UserName;    // The username to use for SMTP authentication. 
   $params["password"] = $SMTP_Password;    // The password to use for SMTP authentication. 
   $params["localhost"] = $EHLO_LocalHost;  // The value to give when sending EHLO or HELO. Default is localhost 

//$params["timeout"] - The SMTP connection timeout. Default is NULL (no timeout) 
//$params["verp"] - Whether to use VERP or not. Default is FALSE 
//$params["debug"] - Whether to enable SMTP debug mode or not. Default is FALSE 
   $params["persist"] = $persist; // Indicates whether or not the SMTP connection should persist over multiple calls to the send() method. 

  // Create the mail object using the Mail::factory method

  $mail_object = & Mail::factory('smtp', $params);

  $mail_object->send($recipients, $headers, $body);
}

// ----------------- SEND USER MAIL ---------------------------------
function send_user_subscription_verify_mail()
{
   global $newsletter, $from_email;
   global $fields, $field_guid, $field_email;
   global $field_fname, $field_lname;
   
   $ok = true; 

   $link = MakeLink(pgSubscribeVerifyMgr);
   $url = $link . '?guid=' . $fields[$field_guid]; 
   $ConfirmationLink =  $url;

   // Read local file from...
   $body = file_get_contents(pgEmailConf);  // "email_conf.txt");

   $tags = array();
   $values = array_values($fields);

   foreach($fields as $k=>$v) 
   {
     //echo $k . "<br>\n";
     $tags[] = "<" . $k . "/>";
   }
   
   $tags[] = "<ConfirmationLink/>";
   $values[] = $ConfirmationLink;
  
   $tags[] = "<NewsLetter/>";
   $values[] = $newsletter;

   $tags[] = "<ConfirmationURL/>";
   $values[] = $link;
  
   $tags[] = "<guid/>";
   $values[] = $fields[$field_guid];
  
   $body = str_ireplace($tags, $values, $body);

//  echo $body;
   $to_email = '"'. $fields[$field_fname]  .' '. $fields[$field_lname]  .'" <'. $fields[$field_email] . '>';
   sendmail($from_email, $to_email, $newsletter, $body, false);
//   die('here');
   return $ok;
}

// ----------------- SEND USER CANCELATION MAIL ---------------------------------
function send_user_cancelation_mail()
{
   global $newsletter, $from_email;
   global $fields, $field_guid, $field_email;
   global $field_fname, $field_lname;
   
   $ok = true;

   $link = MakeLink(pgCancelVerifyMgr);
   $url = $link . '?guid=' . $fields[$field_guid]; 
   $CancelationLink =  $url;

   // Read local file from...
   $body = file_get_contents(pgEmailCancelRequest); 

   $tags = array();
   $values = array_values($fields);

   foreach($fields as $k=>$v) 
   {
     //echo $k . "<br>\n";
     $tags[] = "<" . $k . "/>";
   }
   
   $tags[] = "<CancelationLink/>";
   $values[] = $CancelationLink;
  
   $tags[] = "<NewsLetter/>";
   $values[] = $newsletter;

   $tags[] = "<CancelationURL/>";
   $values[] = $link;
  
   $tags[] = "<guid/>";
   $values[] = $fields[$field_guid];
  
   $body = str_ireplace($tags, $values, $body);

   $to_email = '"'. $fields[$field_fname]  .' '. $fields[$field_lname]  .'" <'. $fields[$field_email] . '>';
   
   sendmail($from_email, $to_email, $newsletter, $body, false);
   return $ok;
}

// ----------------- SEND FRIEND MAIL ---------------------------------
function send_friend_mail($fname, $lname, $email, $friendname)
{
   global $newsletter, $from_email;
   global $fields, $field_guid;
   
   $ok = true;

   $link = MakeLink(pgSubscribeVerifyMgr);
   $url = $link . '?guid=' . $fields[$field_guid]; 
   $ConfirmationLink =  $url;

   // Read local file from...
   $body = file_get_contents(pgEmailFriendConf);  // "email_friendconf.txt");

   $tags = array();
   
   $tags[] = "<friendname/>";
   $values[] = $friendname;

   $tags[] = "<email/>";
   $values[] = $email;

   $tags[] = "<fname/>";
   $values[] = $fname;

   $tags[] = "<lname/>";
   $values[] = $lname;

   $tags[] = "<ConfirmationLink/>";
   $values[] = $ConfirmationLink;
  
   $tags[] = "<NewsLetter/>";
   $values[] = $newsletter;

   $tags[] = "<ConfirmationURL/>";
   $values[] = $link;
  
   $tags[] = "<guid/>";
   $values[] = $fields[$field_guid];
  
   $body = str_ireplace($tags, $values, $body);

//  echo $body;
  $to_email = '"'. $fname .' '. $lname .'" <'. $email . '>';
  //echo $to_email;
  //die('here B');
   sendmail($from_email, $to_email, $newsletter, $body, false);
//   die('here');
   return $ok;
}



function sql_quote( $value )
{
    if( get_magic_quotes_gpc() )
    {
          $value = stripslashes( $value );
    }
	
    //check if this function exists
    if( function_exists( "mysql_real_escape_string" ) )
    {
          $value = mysql_real_escape_string( $value );
    }
    else
    {
          //for PHP version < 4.3.0 use addslashes
          $value = addslashes( $value );
    }
    return $value;
}

?>
